/************      ROUTE ON A TREE           **********/
/************                                                     **********/
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define N 19
#define xorig 320
#define yorig 50
#define pasv 90
#define pash 150
void pause(void);
void putpixel(int xe, int ye, Uint32 col);
Uint32 getpixel(int xe, int ye);
void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c);
void line(int x0,int y0, int x1,int y1, Uint32 c);
void circle( int xo, int yo, int R, Uint32 col);
void filldisc(int xo, int yo, int R,Uint32 col);
SDL_Surface * screen; Uint32 white,color[6],col;
SDL_Surface *text;  SDL_Rect position;TTF_Font *police=NULL;char chiffre[200];
int nbv[N],v[N][N],pred[N],length1,length2,x[N],y[N];

int main(int argc, char ** argv)
{  int i,j,k,ch1[N],pt1,ch2[N],pt2,km1,km2;
   SDL_Init(SDL_INIT_VIDEO); TTF_Init();
   screen=SDL_SetVideoMode(800,600,32, SDL_HWSURFACE|SDL_DOUBLEBUF);
   white=SDL_MapRGB(screen->format,255,255,255);
   color[0]=SDL_MapRGB(screen->format,0,0,0);
   color[1]=SDL_MapRGB(screen->format,255,0,0);
   color[2]=SDL_MapRGB(screen->format,0,250,0);
   color[3]=SDL_MapRGB(screen->format,0,0,250);
   color[4]=SDL_MapRGB(screen->format,255,255,0);
   color[5]=SDL_MapRGB(screen->format,200,200,200);
   SDL_FillRect(screen,0,white);
   police=TTF_OpenFont("times.ttf",30);
    SDL_Color blackcol={0,0,0};
    sprintf( chiffre," PATH  ON TREE");
    text=TTF_RenderText_Solid(police,chiffre,blackcol);
    position.x=20; position.y=20;
    SDL_BlitSurface(text,NULL,screen,&position);

    v[0][0]=1;v[0][1]=2; nbv[0]=2;        v[1][0]=3;v[1][1]=4; nbv[1]=2;
    v[2][0]=5;v[2][1]=6;v[2][2]=7; nbv[2]=3;        nbv[3]=0;
    v[4][0]=8;v[4][1]=9;v[4][2]=10; nbv[4]=3;      nbv[5]=0;
    v[6][0]=11;v[6][1]=12; nbv[6]=2;    nbv[7]=0;    nbv[8]=0;      nbv[9]=0;
    v[10][0]=13;v[10][1]=14; nbv[10]=2;     v[11][0]=15;nbv[11]=1;   nbv[12]=0;    nbv[13]=0;
    v[14][0]=16;v[14][1]=17;v[14][2]=18; nbv[14]=3;   nbv[15]=0;   nbv[16]=0;
    nbv[17]=0;     nbv[18]=0;
    y[0]=yorig;x[0]=xorig;
    for(i=1;i<3;i++) {y[i]=yorig+pasv; x[i]=xorig-100+(i-1)*pash;}
    for(i=3;i<8;i++) {y[i]=yorig+2*pasv;x[i]=xorig-200+(i-3)*pash;}
    for(i=8;i<13;i++) {y[i]=yorig+3*pasv; x[i]=xorig-200+(i-8)*pash;}
    for(i=13;i<16;i++) {y[i]=yorig+4*pasv;x[i]=xorig-200+(i-13)*pash;}
    for(i=16;i<19;i++) {y[i]=yorig+5*pasv;x[i]=xorig-200+(i-16)*pash;}

    for(i=0;i<N;i++)
       { filldisc(x[i],y[i],3,color[3]);
          sprintf( chiffre,"%d ",i);
          text=TTF_RenderText_Solid(police,chiffre,blackcol);
          position.x=x[i]; (position.y)=y[i];
          SDL_BlitSurface(text,NULL,screen,&position);
       }
    for(i=0;i<N;i++)for(j=0;j<nbv[i];j++)  line(x[i],y[i],x[v[i][j]],y[v[i][j]],color[3]);
    for(i=1;i<N;i++)for(j=0;j<nbv[i];j++)  pred[v[i][j]]=i;
    SDL_Flip(screen);pause();
    /*************************************************************/
    pt1=3; pt2=18;   /***********    the two extreme points    *************/
     /*************************************************************/
    sprintf( chiffre,"path from %d  to %d",pt1,pt2);
    text=TTF_RenderText_Solid(police,chiffre,blackcol);
    position.x=450; (position.y)=20;
    SDL_BlitSurface(text,NULL,screen,&position);

    ch1[0]=pt1; k=0;     /** from pt1 to 0 */
    while(ch1[k] != 0)  { k++; ch1[k]=pred[ch1[k-1]]; }
    length1=k+1;
    ch2[0]=pt2; k=0;    /** from pt2 to 0 */
    while(ch2[k] != 0) { k++; ch2[k]=pred[ch2[k-1]];}
    length2=k+1;
    k=0;                      /** froù pt1 to pt2  */
   while(ch1[length1-1-k]==ch2[length2-1-k]) k++;
   km1=length1-1-k; km2=length2-1-k;
   for(i=1;i<=km1+1;i++)
      { circle(x[ch1[i]],y[ch1[i]],5,color[1]);
         linewithwidth(x[ch1[i]],y[ch1[i]],x[ch1[i-1]],y[ch1[i-1]] ,1,color[1] );
      }
   circle(x[ch1[0]],y[ch1[0]],5,color[1]);
   for(i=km2+1;i>0;i--)
     { circle(x[ch2[i]],y[ch2[i]],5,color[1]);
        linewithwidth(x[ch2[i]],y[ch2[i]],x[ch2[i-1]],y[ch2[i-1]] ,1,color[1] );
     }
   circle(x[ch2[0]],y[ch2[0]],5,color[1]);
   SDL_Flip(screen);pause();  TTF_CloseFont(police); TTF_Quit();  return 0;
}

void pause(void)
{
    SDL_Event evenement;
    do   SDL_WaitEvent(&evenement);
    while(evenement.type != SDL_QUIT && evenement.type != SDL_KEYDOWN);
}

void putpixel(int xe, int ye, Uint32 col)
{ Uint32 * numerocase;
numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;    *numerocase=col;
}

Uint32 getpixel(int xe, int ye)
{ Uint32 * numerocase;
   numerocase= (Uint32 *)(screen->pixels)+xe+ye*screen->w;   return (*numerocase);
}

void linewithwidth(int x1, int y1, int x2, int y2, int epaisseur,Uint32 c)
{
int dx,dy;
float k,xf1,yf1,xf2,yf2,d,dx1,dy1,ndx1,ndy1,ndx2,ndy2,angle=M_PI/2.;
line(x1,y1,x2,y2,c);
dx=x2-x1; dy=y2-y1;       d=sqrt(dx*dx+dy*dy);
if (d!=0.)      /* si le vecteur n’est pas nul */
{ dx1=(float)epaisseur*(float)dx/d; dy1=(float)epaisseur*(float)dy/d;
   ndx1=dx1*cos(angle)-dy1*sin(angle);
   ndy1=dx1*sin(angle)+dy1*cos(angle);
   ndx2=dx1*cos(-angle)-dy1*sin(-angle);
   ndy2=dx1*sin(-angle)+dy1*cos(-angle);
   for(k=0;k<=1.;k+=0.1/d)
   {
   xf1=(1.-k)*x1+k*x2; yf1=(1.-k)*y1+k*y2;
   xf2=xf1-ndx1; yf2=yf1-ndy1;  line(xf1,yf1,xf2,yf2,c);
   xf2=xf1-ndx2; yf2=yf1-ndy2;    line(xf1,yf1,xf2,yf2,c);
   }
}
}

/** stair  line */
void line(int x0,int y0, int x1,int y1, Uint32 c)
{
int dx,dy,x,y,residu,absdx,absdy,pasx,pasy,i;
dx=x1-x0; dy=y1-y0;  residu=0;       x=x0;y=y0;  if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
if (dx>0) pasx=1;else pasx=-1; if (dy>0) pasy=1; else pasy=-1;
absdx=abs(dx);absdy=abs(dy);
if (dx==0) for(i=0;i<absdy;i++) { y+=pasy;
                                                    if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c); }
else if(dy==0) for(i=0;i<absdx;i++){ x+=pasx;
                                                         if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);  }
else if (absdx==absdy)
   for(i=0;i<absdx;i++) {x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     y+=pasy;
                                     if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                     }
else if (absdx>absdy)
          for(i=0;i<absdx;i++)
			  { x+=pasx; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			     residu+=absdy;
			     if(residu >= absdx) {residu -=absdx; y+=pasy;
	                              		        if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
			                                    }
			  }
else for(i=0;i<absdy;i++)
             {y+=pasy; if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
               residu +=absdx;
              if (residu>=absdy)   {residu -= absdy;x +=pasx;
                                              if (x>=0 && x<800 && y>=0 && y<600) putpixel(x,y,c);
                                             }
             }
}

void circle( int xo, int yo, int R, Uint32 col)
  {
      int x, y, F, F1, F2,newx,newy;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,col);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, col);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,col);
              newx=2*xo-x ; newy=2*yo-y ;
             if (x<800 && x>=0 && newy>=0 && newy<600) putpixel(x, newy,col);
             if (newx<800 && newx>=0 && y>=0 && y<600) putpixel( newx,y,col);
             if (newx<800 && newx>=0 && newy>=0 && newy<600) putpixel(newx,
             newy, col);
         }
       if (xo+R<800 && xo+R>=0 && yo>=0 && yo<600) putpixel(xo+R,yo,col);
       if (xo-R<800 && xo-R>=0 && yo>=0 && yo<600) putpixel(xo-R,yo, col);
  }

void filldisc( int xo, int yo, int R, Uint32 col)
  {
      int x, y, F, F1, F2,newx,newy,xx;
      x=xo; y=yo+R; F=0;
      if (x<800 && x>=0 && y>=0 && y<600) putpixel(x,y,col);
      if (x<800 && x>=0 && 2*yo-y>=0 && 2*yo-y<600) putpixel (x,2*yo-y, col);
      while( y>yo)
         {
             F1=F+2*(x-xo)+1; F2=F-2*(y-yo)+1;
             if ( abs(F1)<abs(F2))  { x+=1; F=F1;}
             else {y-=1; F=F2;}
             newx=2*xo-x ; newy=2*yo-y ;
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && y>=0 && y<600 )
             putpixel(xx,y,col);
             for(xx=newx; xx<=x; xx++)if (xx<800 && xx>=0 && newy>=0 && newy<600 )
             putpixel(xx,newy,col);
         }
       if (xo+R<800 && xo+R>=0&& y>=0 && y<600) putpixel(xo+R,yo,col);
       if (xo-R<800 && xo-R>=0&& y>=0 && y<600) putpixel(xo-R,yo, col);
  }




